package feature;

import java.io.IOException;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

import cn.edu.tsinghua.stat.ner.NamedEntity;
import cn.edu.tsinghua.stat.ner.NamedEntityRecognizer;
import cn.edu.tsinghua.stat.ner.Phrase;

public class Searcher {
	private static ArrayList<String> Top1000;
	static NamedEntityRecognizer ner = new NamedEntityRecognizer();
	static{
		Top1000 =  new ArrayList<String>();
		
		Scanner t1000;
		try {
			t1000 = new Scanner(Paths.get("/media/sda3/veritas/Wikipedia/new_experiment/DEFAULT/top1000words.txt"), "UTF-8");
			while(t1000.hasNextLine()) {
				String word = t1000.nextLine();
				Top1000.add(word);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
		
	}


	public Searcher() throws IOException{
		String basepath = "/media/sda3/veritas/java_external_jar/Laputa/";
		ner.loadSemanticTypes(basepath+"SemGroups.txt");
		ner.loadAllowedSemanticTypes(basepath+"concepts to crawl.txt");
		System.out.println(ner.loadDictionary(basepath+"cleanterms.txt"));
	}
	
	public double[] search(String firstSentence, String fullText){
			//生成TypeCode与7个Group之间对应的HashMap
		
				HashMap<String, String> SemGroup = new HashMap<String,String>();
				Scanner sc;
				try {
					sc = new Scanner(Paths.get("/media/sda3/veritas/java_external_jar/Laputa/SemGroups.txt"), "UTF-8");
					while(sc.hasNextLine()) {
						String line = sc.nextLine();
						String[] entries = line.split("\\|");
						SemGroup.put(entries[2], entries[0]);
					}
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			
			String[] seperatefirstSentence = firstSentence.toLowerCase().split("\\W+");
		
			double [] flag = new double[3];
			flag[0]=0;
			flag[1]=0;
			flag[2]=0;
			//String [] output = new String[2];
			//String message = new String();
			
			if (seperatefirstSentence.length <5)
			{
				flag [0] = 0;
			}
			else
			{
				boolean Needed = false;
				//boolean ContainBeword = false;
				String[] BeWord = {"is","are","was","were","belongs","belong","consist","consists","refer","refers"};
				String[] Conjunction ={"that","which","who","whom"};
				ArrayList<String> NeededPart = new ArrayList<String>();
				//int wordcount = 0;
				for (String word: seperatefirstSentence) 
				{
					//wordcount++;
					if (Needed == true)
					{
						//System.out.println(word);
						NeededPart.add(word);					
					}
					if (Arrays.asList(BeWord).contains(word))
					{
						Needed = true;
						//ContainBeword = true;
						continue;
					}
					if (Arrays.asList(Conjunction).contains(word))
					{
						break;
					}
					if (NeededPart.size() > 10)
					{
						break;
					}
				}
				/*if (ContainBeword == false)
				{
					NeededPart = new ArrayList<String>(Arrays.asList(seperatefirstSentence));
					if (NeededPart.size() >= 10){
						ArrayList<String> temp= new ArrayList<String>(); 
						for (int i=0;i<10;i++)
						{
							temp.add(NeededPart.get(i));
						}
						NeededPart = temp;	
					}
				}*/
				
				int size = NeededPart.size();
				/*
				for (String NP:NeededPart){
					System.out.print(NP+" ");
				}
				System.out.println(" ");
				*/
				List<NamedEntity> entities = ner.digSentenceGreedy(NeededPart.toArray(new String[size]));
				//System.out.println("Identified " + entities.size());

				
				for (NamedEntity entity: entities) 
				{
					Phrase phrase = entity.getPhrase();
					//System.out.println(phrase.getText());
					//String typeCode = phrase.getTypeCodes().get(0);
					List<String> typeCodes = phrase.getTypeCodes();
					Set<String> groups = new HashSet<String>();
					for (String tc:typeCodes)
					{
						groups.add(SemGroup.get(tc));
					}
					String text = phrase.getText();
					if (text.length() > 3)
					{
						if (ner.isAllowedTypeCode(typeCodes.get(0)))
						{
							if (groups.size() == 1)
							{
								flag[0]=1;
								//System.out.println(text+" belongs to "+ groups);
								//message = text+" belongs to "+ groups;
							}
							if (groups.size() == 2)
							{
								if (!Top1000.contains(text)){
									flag[0]=1;
									//message = text+" belongs to "+ groups + " and not in 3000";
								}
								/*else
								{   //System.out.println(text + " belongs to multiple groups");
									System.out.println(groups);
								}*/
							}
							//if (groups.size() > 2)
							//{
							//	message = text+" belongs to "+ groups + "that's too many.";
							//}
						}
					
					}
				
				}
				String[] seperateFullText = fullText.toLowerCase().split("\\W+");
				List<NamedEntity> entities2 = ner.digSentenceGreedy(seperateFullText);
				for (NamedEntity entity: entities2) {
					Phrase phrase = entity.getPhrase();
					List<String> typeCodes = phrase.getTypeCodes();
					ArrayList<String>groups = new ArrayList<String>();
					for (String tc:typeCodes){
						groups.add(SemGroup.get(tc));
					}
					String text = phrase.getText();
					if (text.length()>3 ){
						if (groups.size() == 1){
							//System.out.println(text+" belongs to "+ groups);
							if (ner.isAllowedTypeCode(typeCodes.get(0)))
							{	
								flag[1]=flag[1]+1;
							}
							else
								flag[2]=flag[2]+1;
						}
					}
				}
			flag[1] = Math.log(flag[1]+1);
			flag[2] = Math.log(flag[2]+1);
			}
			//output[0] = String.valueOf(flag[0]);
			//output[1] = message;

			return flag;
	}

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			Searcher searcher1 = new Searcher();
			String FS = "Alaska () is a U.S. state situated in the northwest extremity of the Americas.";
			String FT = "Alabama () is a state located in the southeastern region of the United States.";
			double[] result = new double[3];
			result = searcher1.search(FS, FT);
			System.out.println(result[0]);
			System.out.println(result[1]);
			System.out.println(result[2]);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
