package feature;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;

public class Word2Vec {
	public HashMap<String,Integer> wordid;
	public int length;//#(word of wordvec matrix)//764366
	public double[][] wordmatrix;
	public int M;//#(the total articles)//5139391
	public int DIM;//word DIMension
	public double[] idf;
	public double[] vecnorm;
	double DEFAULT_VALUE = 0.00000001;
    public Word2Vec(){
	String path="d:\\parseworkdata\\";
	
	try (InputStreamReader isr = new InputStreamReader(new FileInputStream(path+"Word2Vec_AllStemmingArticles_MoreThan2.txt"));
			BufferedReader word_vec = new BufferedReader(isr);//word vector table
			){
		String temp;
		int k=0;
		if((temp=word_vec.readLine())!=null){
			k++;
			String[] firstline = temp.split("\\|");
			String[] tmp = firstline[1].split(" ");
			DIM = tmp.length;
		}
		while(word_vec.readLine()!=null){
			k++;
		}
		length = k;
	}catch (IOException e) {
		System.err.println(e.getMessage());
		System.exit(1);
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	
	try (InputStreamReader isr1 = new InputStreamReader(new FileInputStream(path+"Word2Vec_AllStemmingArticles_MoreThan2.txt"));
			BufferedReader word_vec = new BufferedReader(isr1);//word vector table
			InputStreamReader isr2 = new InputStreamReader(new FileInputStream(path+"IDF_ForAllStemmingArticles.txt"));
			BufferedReader dnum  = new BufferedReader(isr2);//#(documents with the word)
			) {
		String temp;
		int j = 0;
		wordid = new HashMap<String,Integer> ();
		wordmatrix = new double[length][DIM];
		vecnorm = new double[length];
		double temp2;
		while((temp=word_vec.readLine())!=null){
			String[] items = temp.split("\\|");
			wordid.put(items[0],j);
			String[] tmp = items[1].split(" ");
			vecnorm[j] = 0;
			for(int k=0;k<DIM;k++)
				{ temp2 = Double.parseDouble(tmp[k]);
				wordmatrix[j][k]=temp2;
				vecnorm[j] = vecnorm[j] + temp2*temp2;
				}
			if(vecnorm[j]==0){
				System.err.println("Error!!! norm of vector is 0");
				System.exit(1);
			}
			j++;
		}
		idf = new double[length];
		temp=dnum.readLine();
		M=Integer.parseInt(temp);//get the total of articles
		while((temp=dnum.readLine())!=null){
			String[] items = temp.split("\\:");
			if(wordid.get(items[0])!=null){
				 idf[wordid.get(items[0])]=Math.log((double)M/(Double.parseDouble(items[1])+1));
			}
		}
		
	} catch (IOException e) {
		System.err.println(e.getMessage());
		System.exit(1);
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
}
    public Word2Vec(String path_wordvec,String path_word_articlenum){
	try (InputStreamReader isr = new InputStreamReader(new FileInputStream(path_wordvec));
			BufferedReader word_vec = new BufferedReader(isr);//word vector table
			){
		String temp;
		int k=0;
		if((temp=word_vec.readLine())!=null){
			k++;
			String[] firstline = temp.split("\\|");
			String[] tmp = firstline[1].split(" ");
			DIM = tmp.length;
		}
		while(word_vec.readLine()!=null){
			k++;
		}
		length = k;
	}catch (IOException e) {
		System.err.println(e.getMessage());
		System.exit(1);
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	try (InputStreamReader isr1 = new InputStreamReader(new FileInputStream(path_wordvec));
			BufferedReader word_vec = new BufferedReader(isr1);//word vector table
			InputStreamReader isr2 = new InputStreamReader(new FileInputStream(path_word_articlenum));
			BufferedReader dnum  = new BufferedReader(isr2);//#(documents with the word)
			) {
		String temp;
		int j = 0;
		wordid = new HashMap<String,Integer> ();
		wordmatrix = new double[length][DIM];
		vecnorm = new double[length];
		double temp2;
		while((temp=word_vec.readLine())!=null){
			
			String[] items = temp.split("\\|");
			wordid.put(items[0],j);
			String[] tmp = items[1].split(" ");
			vecnorm[j] = 0;
			for(int k=0;k<DIM;k++)
				{ temp2 = Double.parseDouble(tmp[k]);
				wordmatrix[j][k]=temp2;
				vecnorm[j] = vecnorm[j] + temp2*temp2;
				}
			if(vecnorm[j]==0){
				System.err.println("Error!!! norm of vector is 0");
				System.exit(1);
			}
			j++;
		}
		System.out.println("the nrow of word2vec is "+j);
		
		idf = new double[length];
		temp=dnum.readLine();
		M=Integer.parseInt(temp);//get the total of articles
		while((temp=dnum.readLine())!=null){
			String[] items = temp.split("\\:");
			if(wordid.get(items[0])!=null){
				 idf[wordid.get(items[0])]=Math.log((double)M/(Double.parseDouble(items[1])+1));
			}
		}
		
		
		
	} catch (IOException e) {
		System.err.println(e.getMessage());
		System.exit(1);
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
}

    public double[] generate_overuniquenum_vec(String content){
	String[] word = content.split(" ");
	double[] result = new double[DIM];
	int[] count = new int[length];
	int unique_word_num = 0;
	int index;
	double temp;
	for(int i = 0;i<length;i++){
		count[i] = 0;
	}
	for(int i = 0;i<DIM;i++){
		result[i] = 0;
	}
	int wordnum_morethan2 = 0;
	for(int i = 0;i<word.length;i++){
		if(word[i].length()<=2)continue;
		wordnum_morethan2++;
		if(wordid.get(word[i])!=null){
			index = wordid.get(word[i]);
			count[index] ++;
		}
	}
	for(int i = 0;i<length;i++){
		if(count[i]==0)continue;
		unique_word_num++;
		temp = count[i]*idf[i]/Math.sqrt((double)vecnorm[i]);
		for(int j = 0;j<DIM;j++){
			result[j] = result[j] + temp * wordmatrix[i][j];
		}
	}
	if(unique_word_num==0){
		
		for(int i =0;i<DIM;i++){
			result[i] = DEFAULT_VALUE;
		}
		return result;
	}
	temp = wordnum_morethan2*unique_word_num;
	for(int i =0;i<DIM;i++){
		result[i] = result[i]/temp;
	}
	return result;
}

public double[] generate_vec_tfidf(String content){
	String[] word = content.split(" ");
	double[] result = new double[DIM];
	int[] count = new int[length];
	int unique_word_num = 0;
	int index;
	double temp;
	for(int i = 0;i<length;i++){
		count[i] = 0;
	}
	for(int i = 0;i<DIM;i++){
		result[i] = 0;
	}
	int wordnum_morethan2 = 0;
	for(int i = 0;i<word.length;i++){
		if(word[i].length()<=2)continue;
		wordnum_morethan2++;
		if(wordid.get(word[i])!=null){
			index = wordid.get(word[i]);
			count[index] ++;
		}
	}
	for(int i = 0;i<length;i++){
		if(count[i]==0)continue;
		unique_word_num++;
		temp = count[i]*idf[i]/Math.sqrt((double)vecnorm[i]);
		for(int j = 0;j<DIM;j++){
			result[j] = result[j] + temp * wordmatrix[i][j];
		}
	}
	if(unique_word_num==0){
		for(int i =0;i<DIM;i++){
			result[i] = DEFAULT_VALUE;
		}
		return result;
	}
	for(int i =0;i<DIM;i++){
		result[i] = result[i]/wordnum_morethan2;
	}
	return result;
}

public void show(double[] result){
	for(int i = 0;i < result.length;i++){
		System.out.print(result[i]+" ");
	}
	System.out.println();
}
public void show(double[][] matrix,int m,int n){
	for(int i=0;i<m;i++){
		for(int j = 0;j<n;j++){
			System.out.print(matrix[i][j]+" ");
		}
		System.out.println();
	}
}


public static void main(String[] args){
	/*
	long start = System.currentTimeMillis();
	Word2Vec word2vec = new Word2Vec();
	long end = System.currentTimeMillis();
	System.out.println("running time: "+(end-start)+"ms");
	double[] result = word2vec.generate_vec_tfidf("agnostida is an order of arthropod which first develop near the end of the earli cambrian period and thrive dure the middl cambrian thei ar present in the lower cambrian fossil record along with trilobit from the redlichiida corynexochida and ptychopariida order the last agnostid went extinct in the late ordovician the agnostida ar divid into two subord agnostina and eodiscina that ar then subdivid into a number of famili as a group agnostid ar isopyg mean that their pygidium is similar in size and shape to their cephalon most agnostid speci were eyeless the systemat posit of the order agnostida within the class trilobita remain uncertain");
	word2vec.show(result);
	System.out.println(result.length);
	*/
	String path = "C:\\Users\\team\\Desktop\\yls_August\\Second_BINARY\\TrainSet\\traintext\\7class\\test\\";
	long start = System.currentTimeMillis();
	Word2Vec word2vec = new Word2Vec(path+"WORDVEC.txt",path+"IDF.txt");
	long end = System.currentTimeMillis();
	System.out.println("running time: "+(end-start)+"ms");
	try (	InputStreamReader isr = new InputStreamReader(new FileInputStream("C:\\Users\\team\\Desktop\\yls_August\\Second_BINARY\\TrainSet\\traintext\\7class\\LVGcontent_LT.txt"),"UTF-8");
			BufferedReader br = new BufferedReader(isr);
			InputStreamReader isr2 = new InputStreamReader(new FileInputStream(path+"LVGcontent_LT.txt"),"UTF-8");
			BufferedReader br2 = new BufferedReader(isr2);
			PrintWriter train = new PrintWriter(new OutputStreamWriter(new FileOutputStream(path+"trainset.txt"),"UTF-8"));
			PrintWriter test = new PrintWriter(new OutputStreamWriter(new FileOutputStream(path+"testset.txt"),"UTF-8"));
			){
		String temp;
		while((temp = br.readLine())!=null){
			double[] result = word2vec.generate_vec_tfidf(temp);
			for(int i = 0;i<result.length;i++)
			train.write(result[i]+"\t");
			train.write("\n");
		}
		while((temp = br2.readLine())!=null){
			double[] result = word2vec.generate_vec_tfidf(temp);
			for(int i = 0;i<result.length;i++)
			test.write(result[i]+"\t");
			test.write("\n");
		}
		
	} catch (UnsupportedEncodingException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (FileNotFoundException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	
	
}

}
