package firstclassifySVM;
//This program predict svm value for new data
//input is svmModel parameter: it tells program the dim of newdata
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

public class SVMModel {
	int M;// nrow(sv_matrix) the number of sv
	int N;// ncol(sv_matrix) dim
	double SIGMA;
	double B;
	double PROB_MODEL_A;
	double PROB_MODEL_B;
	double[] model_center;// model_center(N)
	double[] model_scale;// model_scale(N)
	double[] coef;// coef(M)

	double[][] sv_matrix;

	SVMModel() {
		String path = "C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\";
		try (InputStreamReader isr2 = new InputStreamReader(new FileInputStream(path + "temp.txt"));
				BufferedReader para = new BufferedReader(isr2);) {
			String temp;

			M = Integer.parseInt(para.readLine());
			N = Integer.parseInt(para.readLine());
			SIGMA = Double.parseDouble(para.readLine());
			B = Double.parseDouble(para.readLine());
			PROB_MODEL_A = Double.parseDouble(para.readLine());
			PROB_MODEL_B = Double.parseDouble(para.readLine());
			model_center = new double[N];
			model_scale = new double[N];
			coef = new double[M];
			sv_matrix = new double[M][N];
			String temp1 = para.readLine();
			String[] tmp1 = temp1.split(" ");
			String temp2 = para.readLine();
			String[] tmp2 = temp2.split(" ");
			int j = 0;
			for (j = 0; j < N; j++) {
				model_center[j] = Double.parseDouble(tmp1[j]);
				model_scale[j] = Double.parseDouble(tmp2[j]);
			}
			temp = para.readLine();
			String[] tmp = temp.split(" ");
			for (j = 0; j < M; j++) {
				coef[j] = Double.parseDouble(tmp[j]);
			}
			int count = 0;
			while ((temp = para.readLine()) != null) {
				tmp1 = temp.split(" ");
				for (j = 0; j < N; j++) {
					sv_matrix[count][j] = Double.parseDouble(tmp1[j]);
				}
				count++;
			}
		} catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public SVMModel(String path) {
		try (InputStreamReader isr2 = new InputStreamReader(new FileInputStream(path));
				BufferedReader para = new BufferedReader(isr2);) {
			String temp;

			M = Integer.parseInt(para.readLine());
			N = Integer.parseInt(para.readLine());
			SIGMA = Double.parseDouble(para.readLine());
			B = Double.parseDouble(para.readLine());
			PROB_MODEL_A = Double.parseDouble(para.readLine());
			PROB_MODEL_B = Double.parseDouble(para.readLine());
			model_center = new double[N];
			model_scale = new double[N];
			coef = new double[M];
			sv_matrix = new double[M][N];
			String temp1 = para.readLine();
			String[] tmp1 = temp1.split(" ");
			String temp2 = para.readLine();
			String[] tmp2 = temp2.split(" ");
			int j = 0;
			for (j = 0; j < N; j++) {
				model_center[j] = Double.parseDouble(tmp1[j]);
				model_scale[j] = Double.parseDouble(tmp2[j]);
			}
			temp = para.readLine();
			String[] tmp = temp.split(" ");
			for (j = 0; j < M; j++) {
				coef[j] = Double.parseDouble(tmp[j]);
			}
			int count = 0;
			while ((temp = para.readLine()) != null) {
				tmp1 = temp.split(" ");
				for (j = 0; j < N; j++) {
					sv_matrix[count][j] = Double.parseDouble(tmp1[j]);
				}
				count++;
			}
			System.out.println("count = " + count);

		} catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}


	void show(double[] x){
		for(int i=0;i<x.length;i++)System.out.print(x[i]+" ");
		System.out.println();
	}
	
public void show() {
		System.out.println("sigma = " + SIGMA);
		System.out.println("M = " + M);
		System.out.println("N = " + N);
		System.out.println("B = " + B);
		System.out.println("prob_a = " + PROB_MODEL_A);
		System.out.println("prob_b = " + PROB_MODEL_B);
		System.out.println("center is ");
		for (int i = 0; i < N; i++) {
			System.out.print(model_center[i] + " ");
		}
		System.out.println("\nscale is ");
		for (int i = 0; i < N; i++) {
			System.out.print(model_scale[i] + " ");
		}
		System.out.println("\ncoef is ");
		for (int i = 0; i < M; i++) {
			System.out.print(coef[i] + " ");
		}
	}

	public double predict(double[] x) {
		double res = 0;
		// scale
		double[] temp = scale(x);
		// compute kernel_mult
		double[] kernel_x = kernel_mult(temp);
		// compute kernel_x * coef-b
		res = crossdot(kernel_x, coef) - B;
		// sigmoid transform
		res = res * PROB_MODEL_A + PROB_MODEL_B;
		if (res < 0)
			return (1.0 / (1 + Math.exp(res)));
		else
			return (Math.exp(-res) / (1 + Math.exp(-res)));
	}

	double[] scale(double[] x) {
		double[] result = new double[N];
		for (int i = 0; i < N; i++) {
			result[i] = (x[i] - model_center[i]) / model_scale[i];
		}
		return result;
	}

	double[] kernel_mult(double[] x) {
		double[] result = new double[M];
		for (int i = 0; i < M; i++) {
			result[i] = 2 * crossdot(sv_matrix[i], x) - crossdot(x) - crossdot(sv_matrix[i]);
			result[i] = Math.exp(SIGMA * result[i]);
		}
		return result;
	}

	public double[] matrix_mult(double[][] A, double[] x) {
		if (A == null || x == null)
			return null;
		int m = A.length;
		int n = A[0].length;
		if (n != x.length)
			return null;
		double temp;
		double result[] = new double[m];
		for (int i = 0; i < m; i++) {
			temp = 0;
			for (int j = 0; j < n; j++) {
				temp = temp + A[i][j] * x[j];
			}
			result[i] = temp;
		}
		return result;
	}
	double[] predict(double[][] matrix){
		int nrow = matrix.length;
		double[] result = new double[nrow];
		for(int i =0;i<nrow;i++){
			result[i]=predict(matrix[i]);
		}
		return result;
	}
	

	public static double[][] read_matrix(String path,int dim) {
		int nrow = 0;
		try (InputStreamReader isr = new InputStreamReader(new FileInputStream(path));
				BufferedReader br = new BufferedReader(isr);) {
			while (br.readLine() != null) {
				nrow++;
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		double[][] matrix = new double[nrow][dim];
		try (InputStreamReader isr = new InputStreamReader(new FileInputStream(path));
				BufferedReader br = new BufferedReader(isr);) {
			String temp;
			int count = 0;
			while ((temp = br.readLine()) != null) {
				String[] tmp = temp.split(" ");
				for (int j = 0; j < dim; j++) {
					matrix[count][j] = Double.parseDouble(tmp[j]);
				}
				count++;
			}
		} catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return matrix;
	}

	/*
	 * public double sigmoid_transform(double res){ res =
	 * res*PROB_MODEL_A+PROB_MODEL_B; if(res<0)return (1.0/(1+Math.exp(res)));
	 * else return(Math.exp(-res)/(1+Math.exp(-res))); }
	 */
	public double crossdot(double[] x, double[] y) {
		/*
		 * if(x == null || y == null) return null; int n = x.length;
		 * if(n!=y.length)return null;
		 */
		int n = x.length;
		double result = 0;
		for (int i = 0; i < n; i++) {
			result = result + x[i] * y[i];
		}
		return result;
	}

	public double crossdot(double[] x) {
		/*
		 * if(x == null || y == null) return null; int n = x.length;
		 * if(n!=y.length)return null;
		 */
		int n = x.length;
		double result = 0;
		for (int i = 0; i < n; i++) {
			result = result + x[i] * x[i];
		}
		return result;
	}

	public static void main(String[] args){
		String path="C:\\Users\\team\\Desktop\\yls_August\\First_BINARY\\PARAMETER\\svmModel_parameter.txt";
		SVMModel model1 = new SVMModel(path);
		model1.show();
		//double[][] matrix = SVMModel.read_matrix("C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\limit5000\\svm_test_304.txt", model1.N);
		//System.out.println("\n==========");
		//model1.show(model1.predict(matrix));
}
}
