package sqlspider;
//This program is to generate 304variables
//input: 4 word.freq table and prior.txt and svmModel parameter.txt(This svmModel should be related to trainingset with dim 304)
//change: basepath
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

import feature.Searcher;
import feature.Word2Vec;
import firstclassifySVM.SVMModel;
import trainset.Generate_Text;
import trainset.WikiText;

public class FirstBINARYclassifer_307{
	double[] prior = new double[2];
	int VEC_DIM;
	double M1=1;
	double M2=1;
	double M3=1;
	double M4=1;
	public HashMap<String,Integer> contentword;
	public HashMap<String,Integer> categoryword;
	public HashMap<String,Integer> infoboxword;
	public HashMap<String,Integer> subtitleword;
	public double[][] wordfreq_content;
	public double[][] wordfreq_category;
	public double[][] wordfreq_infobox;
	public double[][] wordfreq_subtitle;
	
	Word2Vec wordvec;
	SVMModel svmmodel;
	Searcher searcher;
	
public FirstBINARYclassifer_307(String nbpath,String svmmodelpath,String w2vpath){
	try {
		searcher = new Searcher();
	} catch (IOException e1) {
		// TODO Auto-generated catch block
		System.out.println("error on searcher");
		e1.printStackTrace();
	}
		wordvec = new Word2Vec(w2vpath+"WORDVECforBINARYCLASSIFY.txt", w2vpath+"IDFforBINARYCLASSIFY.txt");
		VEC_DIM = 4 + wordvec.DIM + 3;
		//String path="C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\";
		String path=nbpath;
		svmmodel = new SVMModel(svmmodelpath);
	try(
			InputStreamReader isr3 = new InputStreamReader(new FileInputStream(path+"prior.txt"));
			BufferedReader dprior = new BufferedReader(isr3);
			){
		String temp;
		contentword = new HashMap<String,Integer>();
		categoryword = new HashMap<String,Integer>();
		infoboxword = new HashMap<String,Integer>();
		subtitleword = new HashMap<String,Integer>();
		int i = 0;
		while((temp=dprior.readLine())!=null){
			prior[i] = Double.parseDouble(temp);
			i++;
		}
		
	}catch (IOException e) {
		System.err.println(e.getMessage());
		System.exit(1);
	} catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	wordfreq_content = fuzhi(path+"wordfreq_4.txt",2,1).clone();
	wordfreq_category = fuzhi(path+"wordfreq_5.txt",4,2);
	wordfreq_infobox = fuzhi(path+"wordfreq_6.txt",4,3);
	wordfreq_subtitle = fuzhi(path+"wordfreq_7.txt",4,4);
	
}
	public double[][] fuzhi(String path,int column,int type){
		HashMap<String,Integer> hmap;
		switch(type){
		case 1:hmap = contentword;break;
		case 2:hmap = categoryword;break;
		case 3:hmap = infoboxword;break;
		case 4:hmap = subtitleword;break;
		default:hmap = null;break;
		}
		try(
			InputStreamReader isr1 = new InputStreamReader(new FileInputStream(path),"UTF-8");
			BufferedReader dmap = new BufferedReader(isr1);){
			int i = 0;
			while(dmap.readLine()!=null){
				i++;
			}
			double[][] matrix = new double[i][column];
			int j = 0;
			int k = 0;
			
			InputStreamReader isr2 = new InputStreamReader(new FileInputStream(path),"UTF-8");
			BufferedReader dmap2 = new BufferedReader(isr2);
			String temp;
			
			
			while((temp=dmap2.readLine())!=null){
				String[] items = temp.split("\t");
				hmap.put(items[0],j);
				for(k=0;k<column;k++)matrix[j][k]=Double.parseDouble(items[k+1]);
				j++;
			}
			dmap2.close();
			isr2.close();
			return matrix;
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	
	public double[] GetVariable(WikiText doc){
		double prob[] = new double[4];
		String content =Generate_Text.getStemmer(doc.getcontent_p());
		double[] firsen = searcher.search(doc.getFirstSen(), doc.getcontent_p());
		
		double[] word_vec = new double[wordvec.DIM];
		//word_vec = wordvec.generate_vec(content);
		word_vec = wordvec.generate_vec_tfidf(content);
		
		String[] splitword = content.split(" ");
		double x0,x1;
		x0=prior[0];x1=prior[1];
		int i=0;
		for(String temp:splitword){
			if(contentword.get(temp) != null)
				{i = contentword.get(temp);
				x0=x0+wordfreq_content[i][0];
				x1=x1+wordfreq_content[i][1];
			}
		}
		
		//prob[0] = x0/(x0+x1);
		prob[0] = 1.0/(1.0+ Math.exp((x0-x1)/M1));
		
		String category = Generate_Text.getStemmer(doc.getCategory_p());
		splitword = category.split(" ");
		x0=prior[0];x1=prior[1];
		i=0;
		int k =wordfreq_category.length;
		int[] index = new int[k];
		for(int j = 0;j<k;j++)index[j]=0;
		
		for(String temp:splitword){
			if(categoryword.get(temp) != null)
				{i = categoryword.get(temp);
				index[i] = 1;
			}
		}
		for(i = 0;i<k;i++){
			if(index[i]==0){
				x0=x0+wordfreq_category[i][2];
				x1=x1+wordfreq_category[i][3];
			}else{
				x0=x0+wordfreq_category[i][0];
				x1=x1+wordfreq_category[i][1];
			}
		}
		//prob[1] = x0/(x0+x1);
		prob[1] = 1.0/(1.0+ Math.exp((x0-x1)/M2));
		
		String infobox = doc.getinfobox_p();
		splitword = infobox.split(" ");
		x0=prior[0];x1=prior[1];
		i=0;
		k =wordfreq_infobox.length;
		index = new int[k];
		for(int j = 0;j<k;j++)index[j]=0;
		for(String temp:splitword){
			if(infoboxword.get(temp) != null)
				{i = infoboxword.get(temp);
				index[i] = 1;
			}
		}
		for(i = 0;i<k;i++){
			if(index[i]==0){
				x0=x0+wordfreq_infobox[i][2];
				x1=x1+wordfreq_infobox[i][3];
			}else{
				x0=x0+wordfreq_infobox[i][0];
				x1=x1+wordfreq_infobox[i][1];
			}
		}
		
		//prob[2] = x0/(x0+x1);
		prob[2] = 1.0/(1.0+ Math.exp((x0-x1)/M3));
		
		String subtitle = Generate_Text.getStemmer(doc.getsubtitle_p());
		splitword = subtitle.split(" ");
		x0=prior[0];x1=prior[1];
		i=0;
		k =wordfreq_subtitle.length;
		index = new int[k];
		for(int j = 0;j<k;j++)index[j]=0;
		for(String temp:splitword){
			if(subtitleword.get(temp) != null)
				{i = subtitleword.get(temp);
				index[i] = 1;
			}
		}
		for(i = 0;i<k;i++){
			if(index[i]==0){
				x0=x0+wordfreq_subtitle[i][2];
				x1=x1+wordfreq_subtitle[i][3];
			}else{
				x0=x0+wordfreq_subtitle[i][0];
				x1=x1+wordfreq_subtitle[i][1];
			}
		}
		//prob[3] = x0/(x0+x1);
		prob[3] = 1.0/(1.0+ Math.exp((x0-x1)/M4));
		
		
		int len = 4+wordvec.DIM +3;
		double[] result = new double[len];
		i=0;
		while(i<4){//0 1 2 3
			result[i]=prob[i];
			i++;
		}
		while(i < 7){//4 5 6
			result[i] = firsen[i-4];
			i++;
		}
		while(i<len){
			result[i] = word_vec[i-7];
			i++;
		}
		return result;
	}
	public double[] GetVariable(String content,String category,String subtitle,String infobox,String firstsen){
		double prob[] = new double[4];
		double[] firse = searcher.search(firstsen, content);
		double[] word_vec = new double[wordvec.DIM];
		//word_vec = wordvec.generate_vec(content);
		content = Generate_Text.getStemmer(content);
		word_vec = wordvec.generate_vec_tfidf(content);
		
		String[] splitword = content.split(" ");
		double x0,x1;
		x0=prior[0];x1=prior[1];
		int i=0;
		for(String temp:splitword){
			if(contentword.get(temp) != null)
				{i = contentword.get(temp);
				x0=x0+wordfreq_content[i][0];
				x1=x1+wordfreq_content[i][1];
			}
		}
		//prob[0] = x0/(x0+x1);
		prob[0] = 1.0/(1.0+ Math.exp((x0-x1)/M1));
		category = Generate_Text.getStemmer(category);
		splitword = category.split(" ");
		x0=prior[0];x1=prior[1];
		i=0;
		int k =wordfreq_category.length;
		int[] index = new int[k];
		for(int j = 0;j<k;j++)index[j]=0;
		for(String temp:splitword){
			if(categoryword.get(temp) != null)
				{i = categoryword.get(temp);
				index[i] = 1;
			}
		}
		for(i = 0;i<k;i++){
			if(index[i]==0){
				x0=x0+wordfreq_category[i][2];
				x1=x1+wordfreq_category[i][3];
			}else{
				x0=x0+wordfreq_category[i][0];
				x1=x1+wordfreq_category[i][1];
			}
		}
		//prob[1] = x0/(x0+x1);
		prob[1] = 1.0/(1.0+ Math.exp((x0-x1)/M2));
		
		splitword = infobox.split(" ");
		x0=prior[0];x1=prior[1];
		i=0;
		k =wordfreq_infobox.length;
		index = new int[k];
		for(int j = 0;j<k;j++)index[j]=0;
		for(String temp:splitword){
			if(infoboxword.get(temp) != null)
				{i = infoboxword.get(temp);
				index[i] = 1;
			}
		}
		for(i = 0;i<k;i++){
			if(index[i]==0){
				x0=x0+wordfreq_infobox[i][2];
				x1=x1+wordfreq_infobox[i][3];
			}else{
				x0=x0+wordfreq_infobox[i][0];
				x1=x1+wordfreq_infobox[i][1];
			}
		}
		
		prob[2] = 1.0/(1.0+ Math.exp((x0-x1)/M3));
		subtitle = Generate_Text.getStemmer(subtitle);
		splitword = subtitle.split(" ");
		x0=prior[0];x1=prior[1];
		i=0;
		k =wordfreq_subtitle.length;
		index = new int[k];
		for(int j = 0;j<k;j++)index[j]=0;
		for(String temp:splitword){
			if(subtitleword.get(temp) != null)
				{i = subtitleword.get(temp);
				index[i] = 1;
			}
		}
		for(i = 0;i<k;i++){
			if(index[i]==0){
				x0=x0+wordfreq_subtitle[i][2];
				x1=x1+wordfreq_subtitle[i][3];
			}else{
				x0=x0+wordfreq_subtitle[i][0];
				x1=x1+wordfreq_subtitle[i][1];
			}
		}
		prob[3] = 1.0/(1.0+ Math.exp((x0-x1)/M4));
		
		
		int len = 4+wordvec.DIM + 3;
		double[] result = new double[len];
		i=0;
		while(i<4){//0 1 2 3
			result[i]=prob[i];
			i++;
		}
		while(i<7){//4 5 6
			result[i]=firse[i-4];
			i++;
		}
		while(i<len){
			result[i] = word_vec[i-7];
			i++;
		}
		return result;
	}
	
	public double GetProb(WikiText doc){
		return GetProb(GetVariable(doc));
	}
	
	public double GetProb(double[] variables){
		return svmmodel.predict(variables);
	}
	
public static void main(String[] args){
	long start = System.currentTimeMillis();

	//Nb_classifer_stem_304var nb = new Nb_classifer_stem_304var();
	String basepath = "C://Users//team//Desktop//yls_August//";
	FirstBINARYclassifer_307 nb = new FirstBINARYclassifer_307(basepath+"First_BINARY//PARAMETER//",basepath+"First_BINARY//PARAMETER//svmModel_parameter.txt",basepath+"WORDVEC_TABLE//");
	nb.svmmodel.show();
	System.out.println("=========================");
	long end = System.currentTimeMillis();
	System.out.println("running time is " + (end - start) + "ms");
	
	final String url = "jdbc:mysql://127.0.0.1/wiki?useSSL=false";
	final String name = "com.mysql.jdbc.Driver";
	final String user = "root";
	final String password = "";
	try {
		Class.forName(name);
	} catch (ClassNotFoundException e) {
		// TODO Auto-generated catch block
		System.err.println(e.getMessage());
		System.exit(1);
	}
	try (Connection conn = DriverManager.getConnection(url, user, password);

	) {
		Statement ps1 = conn.createStatement();
		String idd = "644909290";
		ResultSet rs = ps1
				.executeQuery("select old_text,page_title from article where page_latest in ("+idd+");");
		while (rs.next()) {
			try {
				WikiText doc = new WikiText(rs.getString(1));
				double[] temp = nb.GetVariable(doc);
				for(int i =0;i<temp.length;i++)
				System.out.print(temp[i]+ " ");
				System.out.println();
				if(Generate_Text.is_disambig(rs.getString(1)))
				System.out.println("disa");
				System.out.println(rs.getString(2)+"  "+nb.GetProb(temp));
			
				
			} catch (Exception e) {
				e.printStackTrace();
				System.out.println("exceERROR:" + e.getMessage());
			}
			
		}

	} catch (SQLException e) {
		System.err.println(e.getMessage());
		System.exit(1);
	}
	double[] empty_var = nb.GetVariable("", "", "", "", "");
	for(int i =0;i<empty_var.length;i++)
		System.out.print(empty_var[i]+"\t");
	
	System.out.println("\nempty text is "+nb.GetProb(empty_var));
	
	
}

}
