from pandas import read_table
from keras.preprocessing.text import Tokenizer
import numpy as np
import gensim

basepath = "/media/sda3/veritas/Wikipedia/new_experiment/EXP2/Second_Train/data/"

###########################
sendata = open(basepath+"LVGfirstsentence.txt",encoding='utf-8')
paradata = open(basepath+"LVGfirstpara.txt",encoding='utf-8')
cttldata = open(basepath+"LVGsection1title.txt",encoding='utf-8')
sen=[]
count = 0
for line in sendata:
    sen.append(line.lower())
    count=count+1;
print(count)
para=[]
count = 0
for line in paradata:
    para.append(line.lower())
    count=count+1;
print(count)
cttl=[]
count = 0
for line in cttldata:
    cttl.append(line.lower())
    count=count+1;
print(count)

tokenizer_sen = Tokenizer()
tokenizer_sen.fit_on_texts(sen)
sequences_sen = tokenizer_sen.texts_to_sequences(sen)
wordcount = tokenizer_sen.word_counts
outputwrite = open(basepath+"wordcount_sen.txt", 'w+')
for x,y in wordcount.items():
    outputwrite.write(str(x)+'\t'+str(y)+'\n')
outputwrite.close()

tokenizer_para = Tokenizer()
tokenizer_para.fit_on_texts(para)
sequences_para = tokenizer_para.texts_to_sequences(para)
wordcount = tokenizer_para.word_counts
outputwrite = open(basepath+"wordcount_para.txt", 'w+')
for x,y in wordcount.items():
    outputwrite.write(str(x)+'\t'+str(y)+'\n')
outputwrite.close()

tokenizer_cttl = Tokenizer()
tokenizer_cttl.fit_on_texts(cttl)
sequences_cttl = tokenizer_cttl.texts_to_sequences(cttl)
wordcount = tokenizer_cttl.word_counts
outputwrite = open(basepath+"wordcount_cttl.txt", 'w+')
for x,y in wordcount.items():
    outputwrite.write(str(x)+'\t'+str(y)+'\n')
outputwrite.close()
####################
EMBEDDING_DIM_cttl = 50
EMBEDDING_DIM_sen = 100
EMBEDDING_DIM_para = 180
##################
print('Preparing embedding matrix.')
sentences = gensim.models.word2vec.LineSentence(basepath+"allfirstsentence.txt")
word2VecModel_sen = gensim.models.Word2Vec(sentences,size=EMBEDDING_DIM_sen,window=5,min_count=8,sg=1,workers=15)#min_count
word2VecModel_sen.save(basepath+'SEN.model')
print('END')
del(sentences)
sentences = gensim.models.word2vec.LineSentence(basepath+"allfirstpara.txt")
word2VecModel_para = gensim.models.Word2Vec(sentences,size=EMBEDDING_DIM_para,window=5,min_count=12,sg=1,workers=15)#min_count
word2VecModel_para.save(basepath+'PARA.model')
del(sentences)
sentences = gensim.models.word2vec.LineSentence(basepath+"allsection1title.txt")
word2VecModel_cttl = gensim.models.Word2Vec(sentences,size=EMBEDDING_DIM_cttl,window=5,min_count=4,sg=1,workers=15)#min_count
word2VecModel_cttl.save(basepath+'CTTL.model')
del(sentences)
############