rm(list=ls())
library(readr)
setwd('/media/sda3/veritas/Wikipedia/new_experiment/EXP2/First_Train')#need revise
Train1<-read_delim("../wikimatchumls/TRAINSET1st.txt",delim = " ",col_names = F)
title <- read_delim("./data/titlename.txt",delim="\t",col_names = F)
final <- merge(title,Train1,by.x = "X2",by.y = "X3",sort = F)
write_delim(final[,c(2,4,1,5)],"./data/TRAINLABEL1st.txt",delim = "\t",col_names=F)
#write_delim(final[,c(1,2,4)],"./data/FINALTRAINLABELusedirect.txt",delim = "\t",col_names=F)

#second
Train2<-read_delim("../wikimatchumls/TRAINSET2nd.txt",delim = " ",col_names = F)
title2 <- read_delim("../Second_Train/data/name.txt",delim="\t",col_names = F)
final2 <- merge(title2,Train2,by.x = "X2",by.y = "X3",sort = F)
write_delim(final2[,c(2,4,1,5)],"../Second_Train/data/TRAINLABEL2nd.txt",delim = "\t",col_names=F)


content<-read_delim("./data/content.txt",delim = "|",col_names = F)
content[is.na(content)]<-""
category<-read_delim("./data/category.txt",delim = "|",col_names = F)
infobox<-read_delim("./data/infobox.txt",delim = "|",col_names = F)
subtitle<-read_delim("./data/subtitle.txt",delim = "|",col_names = F)
table(is.na(infobox$X2))
table(is.na(category$X2))
table(is.na(subtitle$X2))
alldata<-final[,-4]
alldata[,5]<-content$X2
alldata[,6]<-category$X2
alldata[,7]<-infobox$X2
alldata[,8]<-subtitle$X2
alldata[is.na(alldata)]<-""
rm(content,category,infobox,subtitle)
names(alldata)<-c("id","title","title2","is_imp","content","category","infobox","subtitle")
isImp_label<-alldata$is_imp

prior = table(alldata$is_imp)/sum(table(alldata$is_imp))
prior = log(prior)
write.table(as.matrix(prior),"./PARAMETER/prior.txt",col.names = F,row.names = F)
M<-nrow(alldata)
prob_4var<-matrix(0,nrow=M,ncol=4)   
prob_log<-matrix(0,nrow=M,ncol=8)
alldata<-alldata[,-2]

for(N in 4:7){
  if(N==4){Q=12}
  if(N==5){Q=3}
  if(N==6){Q=1}
  if(N==7){Q=4}
  #content 12 category 3 subtitle 4 infobox 1
  #wordcount table
  if(N==4){
    words<-paste(alldata[,N], collapse=" ")
    words <- unlist(strsplit(words, split=" ", fixed=T))
    freq=table(words)
    nm.var = names(freq)[freq > Q]
    nm.var = nm.var[nchar(nm.var)>2]
    wordcount = matrix(0,nrow=length(nm.var),ncol=2)
    wordtotal = rep(0,2)
    rownames(wordcount) = nm.var 
    
    id=which(isImp_label==0)
    words = paste(alldata[id,N], collapse=" ")
    words = unlist(strsplit(words, split=" ", fixed=T))
    freq2 = table(words)
    freq2 = freq2[intersect(names(freq2),nm.var)]
    wordcount[names(freq2),1] = freq2
    id=which(isImp_label==1)
    words = paste(alldata[id,N], collapse=" ")
    words = unlist(strsplit(words, split=" ", fixed=T))
    freq2 = table(words)
    freq2 = freq2[intersect(names(freq2),nm.var)]
    wordcount[names(freq2),2] = freq2
    wordtotal=colSums(wordcount)
    
  }else{
    #bernoulli
    wordtotal = table(isImp_label)
    words<-paste(alldata[,N], collapse=" ")
    words <- unlist(strsplit(words, split=" ", fixed=T))
    freq=table(words)
    nm.var = names(freq)[freq > Q]
    nm.var = nm.var[nchar(nm.var)>2]
    wordcount = matrix(0,nrow=length(nm.var),ncol=2)
    rownames(wordcount) = nm.var 
    id<- which(isImp_label==0)
    unique_train<-NULL
    for(i in 1:length(id)){
      unique_train<-as.vector(c(unique_train,intersect(unique(unlist(strsplit(alldata[id[i],N], split=" ", fixed=T))),nm.var)))
    }
    freq2 <- table(unique_train)
    wordcount[names(freq2),1]<-freq2
    
    id=which(isImp_label==1)
    unique_train<-NULL
    for(i in 1:length(id)){
      unique_train<-as.vector(c(unique_train,intersect(unique(unlist(strsplit(alldata[id[i],N], split=" ", fixed=T))),nm.var)))
    }
    freq2 <- table(unique_train)
    wordcount[names(freq2),2]<-freq2
  }
  
  if(N==4){
    word.freq = t(wordcount+1)/as.vector(wordtotal+length(nm.var))
    word.freq = log(word.freq)
    write.table(t(word.freq),paste0("./PARAMETER/wordfreq_",N,".txt"),col.names = F,quote=F,sep="\t")
  }
  else{
    word.freq = t(wordcount+1)/as.vector(wordtotal+2)
    word.freq0 = log(1-word.freq)
    word.freq = log(word.freq)
    write.table(t(rbind(word.freq,word.freq0)),paste0("./PARAMETER/wordfreq_",N,".txt"),col.names = F,quote=F,sep="\t")
  }
  prob<-matrix(0,nrow=M,ncol=2)
  if(N==4){
    for(i in 1:M){
      x = unlist(strsplit(alldata[i,N], split=" ", fixed=T))
      x = x[x%in%nm.var]
      prob[i,] = rowSums(as.matrix(word.freq[,x]))+prior
    }
  }else {
    for(i in 1:M){
      x = unlist(strsplit(alldata[i,N], split=" ", fixed=T))
      x = unique(x)
      x = x[x%in%nm.var]
      x<-as.vector(x)
      prob[i,] = rowSums(as.matrix(word.freq[,x]))+prior+rowSums(word.freq0[,setdiff(nm.var,x)])
    }
  }
  length(prob)
  prob_4var[,(N-3)]<-1/(exp(prob[,1]-prob[,2])+1)
  prob_log[,(2*N-7)]<-prob[,1]
  prob_log[,(2*N-6)]<-prob[,2]
}#N in 4:7  
#prob_4Var is the 4 text variables 

summary(prob_4var)
summary(prob_4var[which(isImp_label==1),])
summary(prob_4var[which(isImp_label==0),])

write_delim(data.frame(prob_4var),"./PARAMETER/prob_4var.txt",delim = "\t",col_names = F)
write_delim(data.frame(prob_log),"./PARAMETER/prob_log.txt",delim = "\t",col_names = F)


wordvec<-read_delim("./data/wordvec.txt",delim="\t",col_names = F)
wordvec<-wordvec[,-301]
firstvar<-read_delim("./data/firstsen_variables.txt",delim="\t",col_names = F)
firstvar<-firstvar[,-4]
wordvec<-cbind(firstvar,wordvec)
newdata<-data.frame(isImp_label,prob_4var,wordvec)
write_delim(newdata,"./data/whole_trainingset_final_for_SVMTRAIN.txt",col_names = F,delim="\t")



rm(list=setdiff(ls(),"newdata"))
#5fold
library(readr)
setwd('/media/sda3/veritas/Wikipedia/new_experiment/EXP2/First_Train')
newdata = read_delim("./data/whole_trainingset_final_for_SVMTRAIN.txt",delim="\t",col_names = F)

M<-nrow(newdata)
set.seed(274)
id<-sample(1:M,M,replace = F)
m<-floor(M/5)
idset<-NULL
for(i in 1:4) idset[[i]]<-id[((i-1)*m+1):(i*m)]
idset[[5]]<-id[(4*m+1):M]
trainset_id<-NULL
for(i in 1:5){
  trainset_id[[i]]<-setdiff(1:M,idset[[i]])
}

library(kernlab)
#svm training ............


#newdata: the first col is label the rest cols are features
par_fun<-function(c,newdata,trainset,idset0){
  library(kernlab)
  result<-matrix(0,2,5)
  for(k in 1:5)
  {
    svmModel<-ksvm(as.matrix(newdata[trainset[[k]],-1]),newdata[trainset[[k]],1],type="C-svc",kernel="rbfdot",C=c,kpar = "automatic",prob.model=TRUE)
    a<-table(predict(svmModel,as.matrix(newdata[idset0[[k]],-1])),t(newdata[idset0[[k]],1]))
    result[1,k]<-(a[1,1]+a[2,2])/sum(a)
    result[2,k]<-2*a[1,1]/(2*a[1,1]+a[1,2]+a[2,1])
  }
  print(c)
  result
}


library(parallel)
cl.cores <- detectCores()
cl <- makeCluster(cl.cores)
Allresult<-parLapply(cl,seq(1,17,2),par_fun,newdata=newdata,trainset=trainset_id,idset=idset)

#Allresult is the result of training
numm<-length(seq(1,17,2))
accuracy_5f<-matrix(0,numm,5)
f1score_5f<-matrix(0,numm,5)
for(i in 1:numm){
  accuracy_5f[i,]<-Allresult[[i]][1,]
  f1score_5f[i,]<-Allresult[[i]][2,]
}
accuracy1<-apply(accuracy_5f,1,mean)
f1score1<-apply(f1score_5f,1,mean)
plot(accuracy1+f1score1)
plot(accuracy1)
write.table(as.data.frame(accuracy_5f),"./data/accuracy.txt",col.names = F,row.names = F)
write.table(f1score_5f,"./data/f1score.txt",col.names = F,row.names = F)

#9
#7 9 11:0.9518842 0.9522515 0.9518194
#7 9 11:0.9518714 0.9522420 0.9518014
ttmp<-c(8,8.5,9.5,10)
Allresult_2<-parLapply(cl,ttmp,par_fun,newdata=newdata,trainset=trainset_id,idset=idset)
stopCluster(cl)
accuracy_5f2<-matrix(0,length(ttmp),5)
f1score_5f2<-matrix(0,length(ttmp),5)
for(i in 1:length(ttmp)){
  accuracy_5f2[i,]<-Allresult_2[[i]][1,]
  f1score_5f2[i,]<-Allresult_2[[i]][2,]
}
accuracy<-apply(accuracy_5f2,1,mean)
f1score<-apply(f1score_5f2,1,mean)
#plot(accuracy+f1score)
#plot(accuracy)
write.table(as.data.frame(accuracy_5f2),"./data/accuracy2.txt",col.names = F,row.names = F)
write.table(f1score_5f2,"./data/f1score2.txt",col.names = F,row.names = F)
#8 8.5 9 9.5 10
#0.9520138 0.9520570 0.9522515 0.9522947 0.9520570
#0.9519989 0.9520422 0.9522420 0.9522847 0.9520420


#5fold end!  choose c = 9.5

library(kernlab)
svmModel<-ksvm(as.matrix(newdata[,-1]),newdata[,1],type="C-svc",kernel="rbfdot",C=9.5,kpar = "automatic",prob.model=TRUE)
#table(predict(svmModel),newdata$isImp_label)->a
table(predict(svmModel),newdata$X1)->a
(a[1,1]+a[2,2])/sum(a)





oobject<-svmModel
temp<-list()
temp[[1]]<-nrow((xmatrix(oobject)[[1]]))
temp[[2]]<-ncol((xmatrix(oobject)[[1]]))
temp[[3]]<-kpar(kernelf(oobject))$sigma
temp[[4]]<-b(oobject)
temp[[5]]<-prob.model(oobject)[[1]]$A
temp[[6]]<-prob.model(oobject)[[1]]$B
temp[[7]]<-t(scaling(oobject)$x.scale$`scaled:center`)
temp[[8]]<-t(scaling(oobject)$x.scale$`scaled:scale`)
temp[[9]]<-t(coef(oobject)[[1]])
temp[[10]]<-xmatrix(oobject)[[1]]
write_parameter<-function(path,document){
  write(document[[1]],path,append = T)
  write(document[[2]],path,append = T)
  write(document[[3]],path,append = T)
  write(document[[4]],path,append = T)
  write(document[[5]],path,append = T)
  write(document[[6]],path,append = T)
  write.table(document[[7]],path,append = T,col.names = F,row.names = F)
  write.table(document[[8]],path,append = T,col.names = F,row.names = F)
  write.table(document[[9]],path,append = T,col.names = F,row.names = F)
  write.table(document[[10]],path,append = T,col.names = F,row.names = F)
}

write_parameter("./PARAMETER/svmModel_parameter.txt",temp)
