#! /usr/bin/env python
#start_id = 0
#end_id = 1000000
#str_temp = '100'
start_id = 0
end_id = 1000000
str_temp ='0_100'

#start_id = 3000000
#end_id = 7000000
#str_temp ='300_700'

import os
#import datetime
#import torch
#import train
#import mydatasets
import sys
import numpy as np
data_dir = '/media/sda3/veritas/Wikipedia/new_experiment/EXP2/baseline/cnn/'
import torch
import torch.nn as nn
import torch.nn.functional as F
from torch.autograd import Variable
torch.cuda.set_device(1)

class CNN_Text(nn.Module):
    
    def __init__(self, embed_dim = 128):
        super(CNN_Text, self).__init__()
        V = 50511
        D = embed_dim #args.embed_dim
        C = 8 #args.class_num
        Ci = 1
        Co = 100 #args.kernel_num
        Ks = [3,4,5]
        self.embed = nn.Embedding(V, D)
        # self.convs1 = [nn.Conv2d(Ci, Co, (K, D)) for K in Ks]
        self.convs1 = nn.ModuleList([nn.Conv2d(Ci, Co, (K, D)) for K in Ks])
        '''
        self.conv13 = nn.Conv2d(Ci, Co, (3, D))
        self.conv14 = nn.Conv2d(Ci, Co, (4, D))
        self.conv15 = nn.Conv2d(Ci, Co, (5, D))
        '''
        self.dropout = nn.Dropout(0.5)
        self.fc1 = nn.Linear(len(Ks)*Co, C)
    def conv_and_pool(self, x, conv):
        x = F.relu(conv(x)).squeeze(3)  # (N, Co, W)
        x = F.max_pool1d(x, x.size(2)).squeeze(2)
        return x
    def forward(self, x):
        x = self.embed(x)  # (N, W, D)
        #if self.args.static:
        #    x = Variable(x)
        x = x.unsqueeze(1)  # (N, Ci, W, D)
        #print(x.size())
        x = [F.relu(conv(x)).squeeze(3) for conv in self.convs1]  # [(N, Co, W), ...]*len(Ks)
        #print([w.size() for w in x])
        x = [F.max_pool1d(i, i.size(2)).squeeze(2) for i in x]  # [(N, Co), ...]*len(Ks)
        #print([w.size() for w in x])
        x = torch.cat(x, 1)
        #print(x.size())
        x = self.dropout(x)  # (N, len(Ks)*Co)
        logit = self.fc1(x)  # (N, C)
        return logit


class test_loader(object):
    def __init__(self,text_set,batchsize = 250):
        self.BATCHSIZE = batchsize
        self.ALLCOUNT = len(text_set)
        self.text_set = [torch.LongTensor(w) for w in text_set]
        self.len_text_set = torch.LongTensor([len(w) for w in text_set])      
        self.n_batches = int(self.ALLCOUNT / self.BATCHSIZE)
        self.indices = torch.arange(self.ALLCOUNT)  # 句子的数量
    
    def _create_batch(self, k):
        if k==self.n_batches:
            end_id = self.ALLCOUNT
        else:
            end_id = (k + 1) * self.BATCHSIZE
        temp_id = self.indices[k * self.BATCHSIZE:end_id]
        temp_all_count = end_id - (k * self.BATCHSIZE)
        
        inputbatch = [self.text_set[w] for w in temp_id]
        len_batch = self.len_text_set[temp_id]
        maxlen = torch.max(len_batch)
        #maxlen = min(maxlen, 25000)
        batch_input = torch.zeros(temp_all_count,maxlen).long()
        for i in range(temp_all_count):
            batch_input[i][:len_batch[i]] = inputbatch[i]#[:maxlen]           
        
        return batch_input
        
    def __iter__(self):
        for i in range(self.n_batches+1):
            if i == self.n_batches:
                if self.ALLCOUNT % self.BATCHSIZE !=0:
                    yield self._create_batch(i)
                raise StopIteration()
            yield self._create_batch(i)  # return tensor[] and corresponding length


cnn = CNN_Text()
cnn.load_state_dict(torch.load(data_dir+'cnn_model_epoch10_cpu.pkl'))
count = 0
title_all = []
with open('/media/sda3/veritas/Wikipedia/new_experiment/WIKIPEDIA_DATA/ALLSTEMMINGCONTENT_charMT2_ID.txt') as f:
    for line0 in f.readlines():
        title_all.append(line0.strip('\n'))
        count += 1

title_all = title_all[start_id:end_id]

print('START')
all_text_test = np.load(data_dir+'all_text_test.npy',allow_pickle = True)
all_text_test = all_text_test[start_id:end_id]

testloader = test_loader(all_text_test,batchsize = 50)

cnn.eval()
result = []
count = 0
print(count)
for text_batch in testloader:
    torch.cuda.empty_cache()
    label_pre_logit = cnn(text_batch)
    result.append(torch.max(label_pre_logit.data, 1)[1])
    count+= 1
    if count % 2000 == 0:
        print(count)
        #break


print(count)

result = (list(np.concatenate(result)))
with open(data_dir+'cnn_result'+str_temp+'.txt','w') as g:
    for (x,y) in zip(title_all,result):
        g.write(x+'\t'+str(y)+'\n')


with open(data_dir+'cnn_posi_result'+str_temp+'.txt','w') as g:
    for (x,y) in zip(title_all,result):
        if y >0:
            g.write(x+'\t'+str(y)+'\n')

print('END')

